<template>
  <MapX1
      :width="1040"
      :height="1040"
      :els="blocks.els"
      :sub="blocks.sub"
      :x="0"
      :y="0"
  ></MapX1>
</template>

<script>
import MapX1 from "@/components/x1/MapX1";
import { BetonBlock, BlockPack, BrickBlock } from "@/types/block";

const s = 40;

export default {
  name: 'App',
  components: {
    MapX1
  },
  data: () => ({
    blocks: null
  }),
  created () {
    this.blocks = new BlockPack(0, 0, 26 * s, 26 * s);
    this.createLevel([
      [2, 1, 0, 0, 0, 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0,  0, 0],
      [1, 0, 0, 0, 0, 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0,  0, 0],
      [0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0],
      [0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0],
      [0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0],
      [0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0],
      [0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 1, 1, 2, 2, 1, 1,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0],
      [0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 1, 1, 2, 2, 1, 1,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0],

      [0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0],
      [0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0],
      [0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0],
      [0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 0, 0, 0, 0, 0, 0,  0, 0],
      [0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 0, 0, 0, 0, 0, 0,  0, 0],
      [0, 0, 0, 0, 0, 1, 1, 1,  0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 0, 1, 1, 1, 0, 0,  0, 0],
      [2, 2, 0, 0, 1, 1, 1, 1,  0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 0, 1, 1, 1, 0, 0,  2, 2],
      [0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 0, 0, 0, 0, 0, 0,  0, 0],

      [0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 1, 1, 1, 1, 1, 1,  0, 0, 0, 0, 0, 0, 0, 0,  0, 0],
      [0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 1, 1, 1, 1, 1, 1,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0],
      [0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0],
      [0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0],
      [0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0],
      [0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0],
      [0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0],
      [0, 0, 1, 1, 0, 0, 1, 1,  0, 0, 0, 1, 1, 1, 1, 0,  0, 0, 1, 1, 0, 0, 1, 1,  0, 0],

      [0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 0, 1, 0, 0, 1, 0,  0, 0, 0, 0, 0, 0, 0, 0,  0, 0],
      [0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 0, 1, 0, 0, 1, 0,  0, 0, 0, 0, 0, 0, 0, 0,  0, 0]
    ]);
  },
  methods: {
    createLevel (data) {
      for (let i in data) {
        for (let j in data[i]) {
          let v = data[i][j];

          if (v !== 0) {
            if (v === 1) {
              this.blocks.els.push(new BrickBlock(j * s, i * s));
            }
            else if (v === 2) {
              this.blocks.els.push(new BetonBlock(j * s, i * s));
            }
          }
        }
      }

      let fastFind = { 0: {}, 1: {}, 2: {}, 3: {} };
      let ls = 8 * s;

      for (let x = 0; x < 4; x++) {
        for (let y = 0; y < 4; y++) {
          let blockPack = new BlockPack( x * ls, y * ls, ls, ls);
          this.blocks.sub.push(blockPack);
          fastFind[x][y] = blockPack;
        }
      }

      for (let block2 of this.blocks.els) {
        let block = block2;

        fastFind[Math.floor(block.x / ls)][Math.floor(block.y / ls)]
        .els.push(block);
      }

      for (let sub of this.blocks.sub) {
        if (sub.els.length === 0) {
          this.blocks.sub.splice(this.blocks.sub.indexOf(sub), 1);
        }
      }

      ls = 2 * s;

      for (let pack2 of this.blocks.sub) {
        let pack = pack2;

        for (let x = 0; x < 4; x++) {
          for (let y = 0; y < 4; y++) {
            let blockPack = new BlockPack(pack.x + x * ls, pack.y + y * ls, ls, ls);
            pack.sub.push(blockPack);
            fastFind[x][y] = blockPack;
          }
        }

        for (let block2 of pack.els) {
          let block = block2;

          fastFind[Math.floor((block.x - pack.x) / ls)][Math.floor((block.y - pack.y) / ls)]
          .els.push(block);
        }

        for (let sub of pack.sub) {
          if (sub.els.length === 0) {
            pack.sub.splice(pack.sub.indexOf(sub), 1);
          }
        }
      }
    }
  }
}
</script>

<style>
</style>
